-- INVの繰り返し計算部分
-- X(n+1) = (2 - A*X(n))*X(n)を行う
-- 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity INV_repeat is

	port(X      : in std_logic_vector(24 downto 0);    --MSB含む
	     A      : in std_logic_vector(24 downto 0);
	     nextX : out std_logic_vector(24 downto 0));

end INV_repeat;

architecture STRUCTURE of INV_repeat is

signal AX : std_logic_vector(37 downto 0);         -- A*X(n)
signal TwoMinusAX : std_logic_vector(25 downto 0);
signal nextX_buf : std_logic_vector(37 downto 0);

signal Ah : std_logic_vector(12 downto 0);
signal Al : std_logic_vector(11 downto 0);
signal Xh : std_logic_vector(12 downto 0);
signal Xl : std_logic_vector(11 downto 0);
signal AXhh : std_logic_vector(25 downto 0);
signal AXhl : std_logic_vector(24 downto 0);
signal AXlh : std_logic_vector(24 downto 0);
signal AXll : std_logic_vector(23 downto 0);
signal nextXhh : std_logic_vector(25 downto 0);
signal nextXhl : std_logic_vector(24 downto 0);
signal nextXlh : std_logic_vector(24 downto 0);
signal nextXll : std_logic_vector(23 downto 0);

begin -- STRUCTURE

Ah <= A(24 downto 12);
Al <= A(11 downto 0);
Xh <= X(24 downto 12);
Xl <= X(11 downto 0);
AXhh <= Ah * Xh;
AXhl <= Ah * Xl;
AXlh <= Al * Xh;
AXll <= Al * Xl;
AX <= (AXhh & AXll(23 downto 12)) + ("0000000000000" & AXhl) + ("0000000000000" & AXlh);
--AX <= X * A; -- A*X(n) X,Aともに最上位bitは1

TwoMinusAX <= "10000000000000000000000000" - ("0" & AX(37 downto 13));

nextXhh <= TwoMinusAX(24 downto 12) * Xh;
nextXhl <= TwoMinusAX(11 downto  0) * Xh;
nextXlh <= TwoMinusAX(24 downto 12) * Xl;
nextXll <= TwoMinusAX(11 downto  0) * Xl;
nextX_buf <= (nextXhh & nextXll(23 downto 12)) + ("0000000000000" & nextXhl) + ("0000000000000" & nextXlh);
--nextX_buf <= TwoMinusAX(24 downto 0) * X;

nextX <= nextX_buf(37 downto 13) when nextX_buf(37) = '1' else
         nextX_buf(36 downto 12);
                   
end STRUCTURE;
