-- F_ADSB
-- ソースオペランドの符号を判定して
-- FADD_SもしくはFSUB_Sに渡す

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity F_ADSB is

	port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
	     FUNC      : in std_logic_vector(3 downto 0);
	     OUTPUT    : out std_logic_vector(31 downto 0));

end F_ADSB;

architecture STRUCTURE of F_ADSB is
   signal S : std_logic;
   signal FADD_S_OUT : std_logic_vector(31 downto 0);
   signal FSUB_S_OUT : std_logic_vector(31 downto 0);
   --signal SRC3 : std_logic_vector(31 downto 0);
   --signal SRC4 : std_logic_vector(31 downto 0);
   signal FUNCisADD : std_logic;        -- '1' when FUNC is ADD, '0' when FUNC is SUB
   signal USEDisADD : std_logic;        -- '1' when OUTPUT of ADD_s is used for myOUTPUT
   signal SRC2isBIG : std_logic;        -- '1' when ABS(SRC2) > ABS(SRC1)
   signal Equal : std_logic;            -- '1' when ABS(SRC1) = ABS(SRC2)
   signal NaNSub : std_logic;
   signal NaNAdd : std_logic;
   signal ZeroSub : std_logic;
   signal ZeroAdd : std_logic;
   component FADD_S
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            OUTPUT    : out std_logic_vector(31 downto 0);
            NaNout    : out std_logic;
            ZeroOut   : out std_logic);
   end component;
   component FSUB_S
       port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
            OUTPUT    : out std_logic_vector(31 downto 0);
            NaNout    : out std_logic;
            ZeroOut   : out std_logic);
   end component;

begin -- STRUCTURER
    
--   FUNCisADD <= '1' when FUNC = "0000" else '0'; 
--   USEDisADD <= FUNCisADD xor (SRC1(31) xor SRC2(31));
--   SRC2isBIG <= '1' when SRC2(30 downto 0) > SRC1(30 downto 0) else '0';
--   
--   --S <= SRC1(31) when USEDisADD = '1' else SRC1(31) xor SRC2isBIG;
--        
--   FADD_S1 : FADD_S port map (SRC1,SRC2,FADD_S_OUT,NaNAdd);
--   FSUB_S1 : FSUB_S port map (SRC1,SRC2,FSUB_S_OUT,NaNSub);
--   
--   OUTPUT <= "01111111110000000000000000000000" 
--                        when (FUNCisADD and NaNAdd) = '1' or (FUNCisADD = '0' and NaNSub = '1') else
--             FADD_S_OUT when USEDisADD = '1' else
--             FSUB_S_OUT;
             
             
             
   FUNCisADD <= '1' when FUNC = "0000" else '0'; 
   USEDisADD <= FUNCisADD xor (SRC1(31) xor SRC2(31));
   SRC2isBIG <= '1' when SRC2(30 downto 0) > SRC1(30 downto 0) else '0';
   Equal <= '1' when (SRC1(30 downto 0) = SRC2(30 downto 0) -- 等しくても無限,Nansの場合は除外
                      and SRC1(30 downto 23) /= 255) else '0';
   
   S <= SRC1(31) when USEDisADD = '1' else SRC1(31) xor SRC2isBIG;
        
   FADD_S1 : FADD_S port map (SRC1,SRC2,FADD_S_OUT,NaNAdd,ZeroAdd);
   FSUB_S1 : FSUB_S port map (SRC1,SRC2,FSUB_S_OUT,NaNSub,ZeroSub);
   
   OUTPUT <= "01111111110000000000000000000000" -- NaN 
                when (USEDisADD and NaNAdd) = '1' or (USEDisADD = '0' and NaNSub = '1') else
             "00000000000000000000000000000000" -- Zero
                when (USEDisADD and ZeroAdd) = '1' or (USEDisADD = '0' and (ZeroSub = '1' or Equal = '1')) else
             S & FADD_S_OUT(30 downto 0) when USEDisADD = '1' else
             S & FSUB_S_OUT(30 downto 0);          
             
             
    
--   FUNCisADD <= '1' when FUNC = "0000" else '0'; 
--    
----   SRC3 <= SRC1 when (SRC1(31) = '0' and SRC2(31) = '1') and FUNCisADD = '1' else
----           SRC2 when (SRC1(31) = '1' and SRC2(31) = '0') and FUNCisADD = '1' else
----           SRC1;
--   SRC3 <= SRC2 when SRC1(31) = '1' and SRC2(31) = '0' and FUNCisADD = '1' else
--           SRC1;
--   SRC4 <= '0' & SRC2(30 downto 0) when (SRC1(31) = '0' and SRC2(31) = '1') else
--           '0' & SRC1(30 downto 0) when (SRC1(31) = '1' and SRC2(31) = '0') and FUNCisADD = '1' else
--           '1' & SRC2(30 downto 0) when (SRC1(31) = '1' and SRC2(31) = '0') and FUNCisADD = '0' else
--           SRC2;
--   
--   
--   FADD_S1 : FADD_S port map (SRC3,SRC4,FADD_S_OUT);
--   FSUB_S1 : FSUB_S port map (SRC3,SRC4,FSUB_S_OUT);
--
----   OUTPUT <= FSUB_S_OUT when (((SRC1(31) = '0' and SRC2(31) = '1') or 
----                              (SRC1(31) = '1' and SRC2(31) = '0')) and FUNCisADD = '1')
----                              or FUNCisADD = '0' else
----             FADD_S_OUT;
--   
--   OUTPUT <= FADD_S_OUT when ((SRC1(31) = '0' and SRC2(31) = '1') or 
--                              (SRC1(31) = '1' and SRC2(31) = '0')) and FUNCisADD = '0' else
--             FSUB_S_OUT when (((SRC1(31) = '0' and SRC2(31) = '1') or 
--                              (SRC1(31) = '1' and SRC2(31) = '0')) and FUNCisADD = '1')
--                              or FUNCisADD = '0' else
--             FADD_S_OUT;
                        
end STRUCTURE;
