-- FLESS
-- SRC1 < SRC2 で -1
-- SRC1 >= SRC2 で 0

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FLESS is

	port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
	     OUTPUT    : out std_logic_vector(31 downto 0));

end FLESS;

architecture STRUCTURE of FLESS is

signal NaN : std_logic;                       -- Not a Number
signal Inf_sign : std_logic;                  --SRC1 and SRC2 are Infinity and signs of them are equal

begin -- STRUCTURE
   NaN <= '1' when (SRC1(30 downto 23) = 255 and SRC1(22 downto 0) /= 0) or 
                   (SRC2(30 downto 23) = 255 and SRC2(22 downto 0) /= 0) else
          '0';
          
   Inf_sign <= '1' when SRC1(30 downto 0) = "1111111100000000000000000000000"
                    and SRC2(30 downto 0) = "1111111100000000000000000000000"
                    and SRC1(31) = SRC2(31) else
               '0';
   				  
   OUTPUT <= "01111111110000000000000000000000" when NaN = '1' or Inf_sign = '1' else
             "11111111111111111111111111111111"  -- when both of SRC are Normal
        when ((SRC1(31) = '1' and SRC2(31) = '0') or 
              ((SRC1(31) = '0' and SRC2(31) = '0') and (SRC1(30 downto 0) < SRC2(30 downto 0))) or
              ((SRC1(31) = '1' and SRC2(31) = '1') and (SRC1(30 downto 0) > SRC2(30 downto 0))))
        else "00000000000000000000000000000000";                        
end STRUCTURE;

