-- ITOF

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity ITOF is

	port(SRC    : in std_logic_vector(31 downto 0);
	     OUTPUT : out std_logic_vector(31 downto 0));

end ITOF;

architecture STRUCTURE of ITOF is
component Priority31
       port(bits     : in std_logic_vector(31 downto 0);
            Code_out : out std_logic_vector(4 downto 0));
end component;
component LeftShifter31
    	  port(Data    : in std_logic_vector(31 downto 0);
	         nShift  : in std_logic_vector(4 downto 0);
	         Shifted : out std_logic_vector(22 downto 0));
end component;

signal S : std_logic;
signal SRC_abs : std_logic_vector(31 downto 0);
--signal MANT_buf : std_logic_vector(22 downto 0); -- 仮数部の上の1bitは入れていない
signal MANT_buf : std_logic_vector(31 downto 0);
signal MANT_msb : std_logic_vector(4 downto 0);
signal EXP : std_logic_vector(7 downto 0);
signal EXP_buf : std_logic_vector(7 downto 0);

--signal test : std_logic_vector(31 downto 0);

begin -- STRUCTURE
   S <= SRC(31);
   SRC_abs <= '0' & ((not SRC(30 downto 0)) + 1) when SRC(31) = '1' else
              SRC;
              
              --((not SRC(30 downto 0)) + 1) when SRC(31) = '1' else
              --SRC(30 downto 0);
              
              --SRC when SRC(31) = '0' else
              --'0' & ((not SRC(30 downto 0)) + 1); 
   Priority31_1 : Priority31 port map (SRC_abs,MANT_msb);
   
   --LeftShifter31_1 : LeftShifter31 port map (SRC_abs,MANT_msb,MANT_buf);
   --MANT_buf <= shl (SRC_abs,23 - MANT_msb);
   MANT_buf <= shl (SRC_abs,(not MANT_msb)-8);
   
   EXP_buf <= "000" & MANT_msb;
   EXP <= EXP_buf + 127;
   OUTPUT <= S & EXP & MANT_buf(22 downto 0);
end STRUCTURE;
