-- SQRT

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SQRT is

	port(SRC    : in std_logic_vector(31 downto 0);
	     OUTPUT : out std_logic_vector(31 downto 0));

end SQRT;

architecture STRUCTURE of SQRT is
component Subsequent24to26
	port(IN24  : in std_logic_vector(23 downto 0);
	     OUT26 : out std_logic_vector(25 downto 0));
end component;

signal NaNs : std_logic;          -- Not a Number
signal Zero : std_logic;          -- '1' when SRC = 0
signal Inf_p : std_logic;           -- '1' when SRC is positive Infinity
signal S : std_logic;
--signal MANT_is_zero : std_logic;  -- '1' when mantissa of SRC is 0
signal EXP : std_logic_vector(7 downto 0);
signal EXP_buf : std_logic_vector(7 downto 0);
signal MANT : std_logic_vector(26 downto 0);        -- 引き算の繰り返しにより得られる仮数部
signal MANT_rounded : std_logic_vector(22 downto 0);-- MANTを丸めたもの
--signal SRC_MANT_in : std_logic_vector(23 downto 0); -- '1' & "SRCの部"
--signal SRC_MANT : std_logic_vector(25 downto 0);    -- SRC_MANT_inをSequent24to26で桁ぞろえしたもの
signal Win1  : std_logic;
signal Win2  : std_logic;
signal Win3  : std_logic;
signal Win4  : std_logic;
signal Win5  : std_logic;
signal Win6  : std_logic;
signal Win7  : std_logic;
signal Win8  : std_logic;
signal Win9  : std_logic;
signal Win10  : std_logic;
signal Win11  : std_logic;
signal Win12  : std_logic;
signal Win13  : std_logic;
signal Win14  : std_logic;
signal Win15  : std_logic;
signal Win16  : std_logic;
signal Win17  : std_logic;
signal Win18  : std_logic;
signal Win19  : std_logic;
signal Win20  : std_logic;
signal Win21  : std_logic;
signal Win22  : std_logic;
signal Win23  : std_logic;
signal Win24  : std_logic;
signal Win25  : std_logic;
signal Win26  : std_logic;
signal Win27  : std_logic;
signal SRC_MANT1  : std_logic_vector(53 downto 0);
signal SRC_MANT2  : std_logic_vector(53 downto 0);
signal SRC_MANT3  : std_logic_vector(53 downto 0);
signal SRC_MANT4  : std_logic_vector(53 downto 0);
signal SRC_MANT5  : std_logic_vector(53 downto 0);
signal SRC_MANT6  : std_logic_vector(53 downto 0);
signal SRC_MANT7  : std_logic_vector(53 downto 0);
signal SRC_MANT8  : std_logic_vector(53 downto 0);
signal SRC_MANT9  : std_logic_vector(53 downto 0);
signal SRC_MANT10 : std_logic_vector(53 downto 0);
signal SRC_MANT11 : std_logic_vector(53 downto 0);
signal SRC_MANT12 : std_logic_vector(53 downto 0);
signal SRC_MANT13 : std_logic_vector(53 downto 0);
signal SRC_MANT14 : std_logic_vector(53 downto 0);
signal SRC_MANT15 : std_logic_vector(53 downto 0);
signal SRC_MANT16 : std_logic_vector(53 downto 0);
signal SRC_MANT17 : std_logic_vector(53 downto 0);
signal SRC_MANT18  : std_logic_vector(53 downto 0);
signal SRC_MANT19  : std_logic_vector(53 downto 0);
signal SRC_MANT20  : std_logic_vector(53 downto 0);
signal SRC_MANT21 : std_logic_vector(53 downto 0);
signal SRC_MANT22 : std_logic_vector(53 downto 0);
signal SRC_MANT23 : std_logic_vector(53 downto 0);
signal SRC_MANT24 : std_logic_vector(53 downto 0);
signal SRC_MANT25 : std_logic_vector(53 downto 0);
signal SRC_MANT26 : std_logic_vector(53 downto 0);
signal SRC_MANT27 : std_logic_vector(53 downto 0);
--signal SUBj   : std_logic_vector(53 downto 0); -- SRC_MANTから直接引く数
signal SUB    : std_logic_vector(53 downto 0); -- SUBjを計算するための信号
signal SUBj2  : std_logic_vector(53 downto 0);
signal SUB2   : std_logic_vector(53 downto 0);
signal SUBj3  : std_logic_vector(53 downto 0);
signal SUB3   : std_logic_vector(53 downto 0);
signal SUBj4  : std_logic_vector(53 downto 0);
signal SUB4   : std_logic_vector(53 downto 0);
signal SUBj5  : std_logic_vector(53 downto 0);
signal SUB5   : std_logic_vector(53 downto 0);
signal SUBj6  : std_logic_vector(53 downto 0);
signal SUB6   : std_logic_vector(53 downto 0);
signal SUBj7  : std_logic_vector(53 downto 0);
signal SUB7   : std_logic_vector(53 downto 0);
signal SUBj8  : std_logic_vector(53 downto 0);
signal SUB8   : std_logic_vector(53 downto 0);
signal SUBj9  : std_logic_vector(53 downto 0);
signal SUB9   : std_logic_vector(53 downto 0);
signal SUBj10 : std_logic_vector(53 downto 0);
signal SUB10  : std_logic_vector(53 downto 0);
signal SUBj11 : std_logic_vector(53 downto 0);
signal SUB11  : std_logic_vector(53 downto 0);
signal SUBj12 : std_logic_vector(53 downto 0);
signal SUB12  : std_logic_vector(53 downto 0);
signal SUBj13 : std_logic_vector(53 downto 0);
signal SUB13  : std_logic_vector(53 downto 0);
signal SUBj14 : std_logic_vector(53 downto 0);
signal SUB14  : std_logic_vector(53 downto 0);
signal SUBj15 : std_logic_vector(53 downto 0);
signal SUB15  : std_logic_vector(53 downto 0);
signal SUBj16 : std_logic_vector(53 downto 0);
signal SUB16  : std_logic_vector(53 downto 0);
signal SUBj17 : std_logic_vector(53 downto 0);
signal SUB17  : std_logic_vector(53 downto 0);
signal SUBj18 : std_logic_vector(53 downto 0);
signal SUB18  : std_logic_vector(53 downto 0);
signal SUBj19 : std_logic_vector(53 downto 0);
signal SUB19  : std_logic_vector(53 downto 0);
signal SUBj20 : std_logic_vector(53 downto 0);
signal SUB20  : std_logic_vector(53 downto 0);
signal SUBj21 : std_logic_vector(53 downto 0);
signal SUB21  : std_logic_vector(53 downto 0);
signal SUBj22 : std_logic_vector(53 downto 0);
signal SUB22  : std_logic_vector(53 downto 0);
signal SUBj23 : std_logic_vector(53 downto 0);
signal SUB23  : std_logic_vector(53 downto 0);
signal SUBj24 : std_logic_vector(53 downto 0);
signal SUB24  : std_logic_vector(53 downto 0);
signal SUBj25 : std_logic_vector(53 downto 0);
signal SUB25  : std_logic_vector(53 downto 0);
signal SUBj26 : std_logic_vector(53 downto 0);
signal SUB26  : std_logic_vector(53 downto 0);
signal SUBj27 : std_logic_vector(53 downto 0);

begin -- STRUCTURE
   NaNs <= '1' when SRC(31) = '1' or  -- SRC < 0
                    (SRC(30 downto 23) = 255 and SRC(22 downto 0) /= 0) else
           '0';
   Inf_p <= '1' when SRC = "01111111100000000000000000000000" else
            '0';
   Zero <= '1' when SRC(30 downto 0) = "0000000000000000000000000000000" else
           '0';
   -- ?        
   --MANT_is_zero <= '1' when SRC(22 downto 0) = "00000000000000000000000" else
   --                '0';
   -- ?        
   S <= '0';
   
   EXP_buf <= SRC(30 downto 23) - 127;        -- newEXP = oldEXP/2(切捨て)
   EXP <= ('0' & EXP_buf(7 downto 1)) + 127 when EXP_buf(7) = '0' else -- 127 <= EXP <= 254
          ('1' & EXP_buf(7 downto 1)) + 127;                           --   1 <= EXP <= 126
   
   
   -- ↓ここから新しい
   SRC_MANT1 <= '1' & SRC(22 downto 0) & "000000000000000000000000000000" 
                   when EXP_buf(0) = '1' else
                "01" & SRC(22 downto 0) & "00000000000000000000000000000";
   -- ↑ここまで新しい
   
   ---- ↓ここから昔の(Subsequent24to26使用)
   --SRC_MANT_in <= '1' & SRC(22 downto 0);
   --Subsequent24to26_1 : Subsequent24to26 port map (SRC_MANT_in,SRC_MANT);
   --MANT(25) <= '1' when SRC_MANT(25 downto 24) >= "01" else
   --            '0';
   ---- ?            
   --SRC_MANT1 <= --SRC_MANT(24 downto 0) & "000000000000000000000000000" 
   --             --  when EXP_buf(0) = '1' and SRC_MANT(25) = '0' else
   --             --'0' & SRC_MANT & "0000000000000000000000000" 
   --             --  when EXP_buf(0) = '1' and SRC_MANT(25) = '1' else
   --             SRC_MANT & "00000000000000000000000000";
   ---- ?
   ---- ↑ここまで昔の
   
   
   -- 1bit
   Win1 <= '1' when SRC_MANT1(53 downto 52) >= "01" else
           '0';
   MANT(26) <= '1' when Win1 = '1' else
               '0';
   SRC_MANT2 <= SRC_MANT1 - "010000000000000000000000000000000000000000000000000000" when Win1 = '1' else
                SRC_MANT1;
   SUB <= "100000000000000000000000000000000000000000000000000000" when Win1 = '1' else
          "000000000000000000000000000000000000000000000000000000";
   -- 2bit
   SUBj2 <= '0' & (SUB(53 downto 1) + "00100000000000000000000000000000000000000000000000000");
   Win2 <= '1' when SRC_MANT2 >= SUBj2 else
           '0';
   MANT(25) <= '1' when Win2 = '1' else
               '0';
   SRC_MANT3 <= SRC_MANT2 - SUBj2 when Win2 = '1' else
                SRC_MANT2;
   SUB2 <= SUB + "010000000000000000000000000000000000000000000000000000" when Win2 = '1' else
           SUB;-- + "000000000000000000000000000000000000000000000000000000";
   -- 3bit
   SUBj3 <= "00" & (SUB2(53 downto 2) + "0001000000000000000000000000000000000000000000000000");
   Win3 <= '1' when SRC_MANT3 >= SUBj3 else
           '0';
   MANT(24) <= '1' when Win3 = '1' else
               '0';
   SRC_MANT4 <= SRC_MANT3 - SUBj3 when Win3 = '1' else
                SRC_MANT3;
   SUB3 <= SUB2 + "001000000000000000000000000000000000000000000000000000" when Win3 = '1' else
           SUB2;
   -- 4bit
   SUBj4 <= "000" & (SUB3(53 downto 3) + "000010000000000000000000000000000000000000000000000");
   Win4 <= '1' when SRC_MANT4 >= SUBj4 else
           '0';
   MANT(23) <= '1' when Win4 = '1' else
               '0';
   SRC_MANT5 <= SRC_MANT4 - SUBj4 when Win4 = '1' else
                SRC_MANT4;
   SUB4 <= SUB3 + "000100000000000000000000000000000000000000000000000000" when Win4 = '1' else
           SUB3;
   -- 5bit
   SUBj5 <= "0000" & (SUB4(53 downto 4) + "00000100000000000000000000000000000000000000000000");
   Win5 <= '1' when SRC_MANT5 >= SUBj5 else
           '0';
   MANT(22) <= '1' when Win5 = '1' else
               '0';
   SRC_MANT6 <= SRC_MANT5 - SUBj5 when Win5 = '1' else
                SRC_MANT5;
   SUB5 <= SUB4 + "000010000000000000000000000000000000000000000000000000" when Win5 = '1' else
           SUB4;
   -- 6bit
   SUBj6 <= "00000" & (SUB5(53 downto 5) + "0000001000000000000000000000000000000000000000000");
   Win6 <= '1' when SRC_MANT6 >= SUBj6 else
           '0';
   MANT(21) <= '1' when Win6 = '1' else
               '0';
   SRC_MANT7 <= SRC_MANT6 - SUBj6 when Win6 = '1' else
                SRC_MANT6;
   SUB6 <= SUB5 + "000001000000000000000000000000000000000000000000000000" when Win6 = '1' else
           SUB5;
   -- 7bit
   SUBj7 <= "000000" & (SUB6(53 downto 6) + "000000010000000000000000000000000000000000000000");
   Win7 <= '1' when SRC_MANT7 >= SUBj7 else
           '0';
   MANT(20) <= '1' when Win7 = '1' else
               '0';
   SRC_MANT8 <= SRC_MANT7 - SUBj7 when Win7 = '1' else
                SRC_MANT7;
   SUB7 <= SUB6 + "000000100000000000000000000000000000000000000000000000" when Win7 = '1' else
           SUB6;
   -- 8bit
   SUBj8 <= "0000000" & (SUB7(53 downto 7) + "00000000100000000000000000000000000000000000000");
   Win8 <= '1' when SRC_MANT8 >= SUBj8 else
           '0';
   MANT(19) <= '1' when Win8 = '1' else
               '0';
   SRC_MANT9 <= SRC_MANT8 - SUBj8 when Win8 = '1' else
                SRC_MANT8;
   SUB8 <= SUB7 + "000000010000000000000000000000000000000000000000000000" when Win8 = '1' else
           SUB7;
   -- 9bit
   SUBj9 <= "00000000" & (SUB8(53 downto 8) + "0000000001000000000000000000000000000000000000");
   Win9 <= '1' when SRC_MANT9 >= SUBj9 else
           '0';
   MANT(18) <= '1' when Win9 = '1' else
               '0';
   SRC_MANT10 <= SRC_MANT9 - SUBj9 when Win9 = '1' else
                 SRC_MANT9;
   SUB9 <= SUB8 + "000000001000000000000000000000000000000000000000000000" when Win9 = '1' else
           SUB8;
   -- 10bit
   SUBj10 <= "000000000" & (SUB9(53 downto 9) + "000000000010000000000000000000000000000000000");
   Win10 <= '1' when SRC_MANT10 >= SUBj10 else
            '0';
   MANT(17) <= '1' when Win10 = '1' else
               '0';
   SRC_MANT11 <= SRC_MANT10 - SUBj10 when Win10 = '1' else
                 SRC_MANT10;
   SUB10 <= SUB9 + "000000000100000000000000000000000000000000000000000000" when Win10 = '1' else
            SUB9;
   -- 11bit
   SUBj11 <= "0000000000" & (SUB10(53 downto 10) + "00000000000100000000000000000000000000000000");
   Win11 <= '1' when SRC_MANT11 >= SUBj11 else
            '0';
   MANT(16) <= '1' when Win11 = '1' else
               '0';
   SRC_MANT12 <= SRC_MANT11 - SUBj11 when Win11 = '1' else
                 SRC_MANT11;
   SUB11 <= SUB10 + "000000000010000000000000000000000000000000000000000000" when Win11 = '1' else
            SUB10;
   -- 12bit
   SUBj12 <= "00000000000" & (SUB11(53 downto 11) + "0000000000001000000000000000000000000000000");
   Win12 <= '1' when SRC_MANT12 >= SUBj12 else
            '0';
   MANT(15) <= '1' when Win12 = '1' else
               '0';
   SRC_MANT13 <= SRC_MANT12 - SUBj12 when Win12 = '1' else
                 SRC_MANT12;
   SUB12 <= SUB11 + "000000000001000000000000000000000000000000000000000000" when Win12 = '1' else
            SUB11;
   -- 13bit
   SUBj13 <= "000000000000" & (SUB12(53 downto 12) + "000000000000010000000000000000000000000000");
   Win13 <= '1' when SRC_MANT13 >= SUBj13 else
            '0';
   MANT(14) <= '1' when Win13 = '1' else
               '0';
   SRC_MANT14 <= SRC_MANT13 - SUBj13 when Win13 = '1' else
                 SRC_MANT13;
   SUB13 <= SUB12 + "000000000000100000000000000000000000000000000000000000" when Win13 = '1' else
            SUB12;
   -- 少なくともここまではちゃんと(?)計算できているはず
   -- 14bit
   SUBj14 <= "0000000000000" & (SUB13(53 downto 13) + "00000000000000100000000000000000000000000");
   Win14 <= '1' when SRC_MANT14 >= SUBj14 else
            '0';
   MANT(13) <= '1' when Win14 = '1' else
               '0';
   SRC_MANT15 <= SRC_MANT14 - SUBj14 when Win14 = '1' else
                 SRC_MANT14;
   SUB14 <= SUB13 + "000000000000010000000000000000000000000000000000000000" when Win14 = '1' else
            SUB13;
   -- 15bit
   SUBj15 <= "00000000000000" & (SUB14(53 downto 14) + "0000000000000001000000000000000000000000");
   Win15 <= '1' when SRC_MANT15 >= SUBj15 else
            '0';
   MANT(12) <= '1' when Win15 = '1' else
               '0';
   SRC_MANT16 <= SRC_MANT15 - SUBj15 when Win15 = '1' else
                 SRC_MANT15;
   SUB15 <= SUB14 + "000000000000001000000000000000000000000000000000000000" when Win15 = '1' else
            SUB14;
   -- 16bit
   SUBj16 <= "000000000000000" & (SUB15(53 downto 15) + "000000000000000010000000000000000000000");
   Win16 <= '1' when SRC_MANT16 >= SUBj16 else
            '0';
   MANT(11) <= '1' when Win16 = '1' else
               '0';
   SRC_MANT17 <= SRC_MANT16 - SUBj16 when Win16 = '1' else
                 SRC_MANT16;
   SUB16 <= SUB15 + "000000000000000100000000000000000000000000000000000000" when Win16 = '1' else
            SUB15;
   -- 17bit
   SUBj17 <= "0000000000000000" & (SUB16(53 downto 16) + "00000000000000000100000000000000000000");
   Win17 <= '1' when SRC_MANT17 >= SUBj17 else
            '0';
   MANT(10) <= '1' when Win17 = '1' else
               '0';
   SRC_MANT18 <= SRC_MANT17 - SUBj17 when Win17 = '1' else
                 SRC_MANT17;
   SUB17 <= SUB16 + "000000000000000010000000000000000000000000000000000000" when Win17 = '1' else
            SUB16;
   -- 18bit
   SUBj18 <= "00000000000000000" & (SUB17(53 downto 17) + "0000000000000000001000000000000000000");
   Win18 <= '1' when SRC_MANT18 >= SUBj18 else
            '0';
   MANT(9) <= '1' when Win18 = '1' else
               '0';
   SRC_MANT19 <= SRC_MANT18 - SUBj18 when Win18 = '1' else
                 SRC_MANT18;
   SUB18 <= SUB17 + "000000000000000001000000000000000000000000000000000000" when Win18 = '1' else
            SUB17;
   -- 19bit
   SUBj19 <= "000000000000000000" & (SUB18(53 downto 18) + "000000000000000000010000000000000000");
   Win19 <= '1' when SRC_MANT19 >= SUBj19 else
            '0';
   MANT(8) <= '1' when Win19 = '1' else
              '0';
   SRC_MANT20 <= SRC_MANT19 - SUBj19 when Win19 = '1' else
                 SRC_MANT19;
   SUB19 <= SUB18 + "000000000000000000100000000000000000000000000000000000" when Win19 = '1' else
            SUB18;
   -- 20bit
   SUBj20 <= "0000000000000000000" & (SUB19(53 downto 19) + "00000000000000000000100000000000000");
   Win20 <= '1' when SRC_MANT20 >= SUBj20 else
            '0';
   MANT(7) <= '1' when Win20 = '1' else
              '0';
   SRC_MANT21 <= SRC_MANT20 - SUBj20 when Win20 = '1' else
                 SRC_MANT20;
   SUB20 <= SUB19 + "000000000000000000010000000000000000000000000000000000" when Win20 = '1' else
            SUB19;
   -- 21bit
   SUBj21 <= "00000000000000000000" & (SUB20(53 downto 20) + "0000000000000000000001000000000000");
   Win21 <= '1' when SRC_MANT21 >= SUBj21 else
            '0';
   MANT(6) <= '1' when Win21 = '1' else
              '0';
   SRC_MANT22 <= SRC_MANT21 - SUBj21 when Win21 = '1' else
                 SRC_MANT21;
   SUB21 <= SUB20 + "000000000000000000001000000000000000000000000000000000" when Win21 = '1' else
            SUB20;
   -- 22bit
   SUBj22 <= "000000000000000000000" & (SUB21(53 downto 21) + "000000000000000000000010000000000");
   Win22 <= '1' when SRC_MANT22 >= SUBj22 else
            '0';
   MANT(5) <= '1' when Win22 = '1' else
              '0';
   SRC_MANT23 <= SRC_MANT22 - SUBj22 when Win22 = '1' else
                 SRC_MANT22;
   SUB22 <= SUB21 + "000000000000000000000100000000000000000000000000000000" when Win22 = '1' else
            SUB21;
   -- 23bit
   SUBj23 <= "0000000000000000000000" & (SUB22(53 downto 22) + "00000000000000000000000100000000");
   Win23 <= '1' when SRC_MANT23 >= SUBj23 else
            '0';
   MANT(4) <= '1' when Win23 = '1' else
              '0';
   SRC_MANT24 <= SRC_MANT23 - SUBj23 when Win23 = '1' else
                 SRC_MANT23;
   SUB23 <= SUB22 + "000000000000000000000010000000000000000000000000000000" when Win23 = '1' else
            SUB22;
   -- 24bit
   SUBj24 <= "00000000000000000000000" & (SUB23(53 downto 23) + "0000000000000000000000001000000");
   Win24 <= '1' when SRC_MANT24 >= SUBj24 else
            '0';
   MANT(3) <= '1' when Win24 = '1' else
              '0';
   SRC_MANT25 <= SRC_MANT24 - SUBj24 when Win24 = '1' else
                 SRC_MANT24;
   SUB24 <= SUB23 + "000000000000000000000001000000000000000000000000000000" when Win24 = '1' else
            SUB23;
   -- 25bit
   SUBj25 <= "000000000000000000000000" & (SUB24(53 downto 24) + "000000000000000000000000010000");
   Win25 <= '1' when SRC_MANT25 >= SUBj25 else
            '0';
   MANT(2) <= '1' when Win25 = '1' else
              '0';
   SRC_MANT26 <= SRC_MANT25 - SUBj25 when Win25 = '1' else
                 SRC_MANT25;
   SUB25 <= SUB24 + "000000000000000000000000100000000000000000000000000000" when Win25 = '1' else
            SUB24;
   -- 26bit
   SUBj26 <= "0000000000000000000000000" & (SUB25(53 downto 25) + "00000000000000000000000000100");
   Win26 <= '1' when SRC_MANT26 >= SUBj26 else
            '0';
   MANT(1) <= '1' when Win26 = '1' else
              '0';
   SRC_MANT27 <= SRC_MANT26 - SUBj26 when Win26 = '1' else
                 SRC_MANT26;
   SUB26 <= SUB25 + "000000000000000000000000010000000000000000000000000000" when Win26 = '1' else
            SUB25;
   -- 27bit
   SUBj27 <= "00000000000000000000000000" & (SUB26(53 downto 26) + "0000000000000000000000000001");
   Win27 <= '1' when SRC_MANT27 >= SUBj27 else
            '0';
   MANT(0) <= '1' when Win27 = '1' else
              '0';
   --SRC_MANT27 <= SRC_MANT26 - SUBj26 when Win26 = '1' else
   --              SRC_MANT26;
   --SUB26 <= SUB25 + "000000000000000000000000010000000000000000000000000000" when Win26 = '1' else
   --         SUB25;
   
   --丸め
   MANT_rounded <= MANT(25 downto 3) + 1 
                      when ((MANT(2) and (MANT(3) or MANT(1))) = '1') and MANT(26) = '1' else
                   MANT(24 downto 2) + 1 
                      when ((MANT(1) and (MANT(2) or MANT(0))) = '1') and MANT(26) = '0' else
                   MANT(24 downto 2) 
                      when MANT(26) = '0' else
                   MANT(25 downto 3);
                   --MANT(25 downto 3) + 1 
                   --   when ((MANT(2) and (MANT(3) or MANT(1))) = '1') and EXP_buf(0) = '1' else
                   --MANT(24 downto 2) + 1 
                   --   when ((MANT(1) and (MANT(2) or MANT(0))) = '1') and EXP_buf(0) = '0' else
                   --MANT(24 downto 2) 
                   --   when EXP_buf(0) = '0' else
                   --MANT(25 downto 3);
   
   OUTPUT <= "01111111110000000000000000000000" when NaNs = '1' else
             "01111111100000000000000000000000" when Inf_p = '1' else
             "00000000000000000000000000000000" when Zero = '1' else
             S & EXP & MANT_rounded;
             --S & EXP & MANT(24 downto 2);--丸めなし
             --SRC_MANT & "000000";-- for Subsequent24to26 test
end STRUCTURE;
